#include <cppunit/BriefTestProgressListener.h>
#include <cppunit/CompilerOutputter.h>
#include <cppunit/extensions/TestFactoryRegistry.h>
#include <cppunit/TestResult.h>
#include <cppunit/TestResultCollector.h>
#include <cppunit/TestRunner.h>

int main(int argc, char* argv[]) {
	CPPUNIT_NS::TestResult controller;
	
	// Add a listener to collect the test results.
	CPPUNIT_NS::TestResultCollector result;
	controller.addListener(&result);
	
	// Add a listener to show progress.
	CPPUNIT_NS::BriefTestProgressListener progress;
	controller.addListener(&progress);
	
	// Run all the tests.
	CPPUNIT_NS::TestRunner runner;
	runner.addTest(CPPUNIT_NS::TestFactoryRegistry::getRegistry().makeTest());
	runner.run(controller);
	
	// Write the results out to stdout.
	CPPUNIT_NS::CompilerOutputter outputter(&result, CPPUNIT_NS::stdCOut());
	outputter.write();
	
	return result.wasSuccessful() ? 0 : 1;
}
